/* Copyright 2004, 2005 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef COLOR_H
#define COLOR_H

namespace SharpConstruct
{
	class Color
	{
	public:
		Color();
		Color( float, float, float );
		~Color();
	
		bool IsGrey() const;
		void SetToBlack();
	
		float Red, Green, Blue;
	
		Color operator+( const Color& c ) const;
		Color operator+( const float c ) const;
		Color operator-( const Color& c ) const;
		Color operator-( const float c ) const;
		Color operator*( const float c ) const;
		void operator+=( const Color& c );
		void operator/=( const int d );
	};
	
	Color MixColors( const Color& c1, const Color& c2 );
	Color MixColors( const Color& c1, const Color& c2, const Color& c3 );
	Color MixColors( const Color& c1, const Color& c2, const Color& c3,
	                 const Color& c4 );

	class UV
	{
	public:
		UV()
		{}
		UV( float u, float v ) : U( u ), V( v )
		{}

		float U, V;
	};
}

#endif // COLOR_H
