/* Copyright 2004, 2005 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef SCULPT_HH
#define SCULPT_HH

namespace SharpConstruct
{
	class SculptPhase
	{};
	class SculptStart : public SculptPhase
	{};
	class SculptContinue : public SculptPhase
	{};
	class SculptEnd : public SculptPhase
	{};

	class ActiveData
	{
	public:
		ActiveData( const unsigned i, const float s )
		: index_( i ), strength_( s )
		{}

		const unsigned& Index() const
		{
			return index_;
		}

		const float& Strength() const
		{
			return strength_;
		}
	private:
		unsigned index_;
		float strength_;
	};
}

#endif
