/* Copyright 2005 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef SMOOTHBRUSH_HH
#define SMOOTHBRUSH_HH

#include "Sculpt.hh"
#include <vector>

namespace SharpConstruct
{
	class EditData;
	class Mesh;

	class SmoothBrush
	{
	public:
		SmoothBrush( SculptPhase, Mesh& mesh );

		void operator()( SculptPhase, EditData e );

		void Postwork( SculptPhase );
	private:
		Mesh& mesh_;
		std::vector< ActiveData > active_data_;
	};
}

#endif
