/* Copyright 2005 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef UTILITIES_H
#define UTILITIES_H

#include <sstream>

namespace SharpConstruct
{
	class Resource
	{
	public:
		Resource()
		: _users( 0 )
		{}

		bool Used() const
		{
			return _users != 0;
		}
		void Grab()
		{
			_users++;
		}
		void Release()
		{
			_users--;
		}
	private:
		int _users;
	};

	std::string ToString( const double );
	std::string ToString( const float );
	std::string ToString( const char );
	std::string ToString( const bool );
	float ToFloat( std::string );
	int ToInt( std::string );

	std::string StripSpaces( std::string x );

	double Time();
	
	std::string GetVersion();
}

#endif
