/* Copyright 2004, 2005 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "Polygon3D.h"

using namespace SharpConstruct;

Triangle::Triangle( unsigned i1, unsigned i2, unsigned i3 )
{
	V[ 0 ] = i1;
	V[ 1 ] = i2;
	V[ 2 ] = i3;
}

void Triangle::ReverseVertices()
{
	std::swap( V[ 0 ], V[ 2 ] );
}
	
Quad::Quad( unsigned i1, unsigned i2, unsigned i3, unsigned i4 )
{
	V[ 0 ] = i1;
	V[ 1 ] = i2;
	V[ 2 ] = i3;
	V[ 3 ] = i4;
}

void Quad::ReverseVertices()
{
	std::swap( V[ 0 ], V[ 3 ] );
	std::swap( V[ 1 ], V[ 2 ] );
}

Polygon3D::Polygon3D()
{}

Polygon3D::~Polygon3D()
{}
